package kaendfinger.UpgradeMaterials;

import java.util.logging.Logger;

import cpw.mods.fml.common.FMLLog;
import net.minecraft.src.Block;
import net.minecraft.src.Item;
import net.minecraft.src.ItemStack;
import net.minecraftforge.common.Configuration;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.Init;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.Mod.PostInit;
import cpw.mods.fml.common.Mod.PreInit;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.network.NetworkMod;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.LanguageRegistry;

@Mod(modid = "UpgradeMaterials", name = "Upgrade Materials", version = "0.1")
@NetworkMod(clientSideRequired = true, serverSideRequired = false)

public class UpgradeMaterialsMain {
	@Instance("UpgradeMaterials")
	public static UpgradeMaterialsMain instance;
	
	@SidedProxy(clientSide="kaendfinger.UpgradeMaterials.client.ClientProxy",
			serverSide="kaendfinger.UpgradeMaterials.CommonProxy")
	public static CommonProxy proxy;
	@PreInit
	public void preInit(FMLPreInitializationEvent event) {
	    public static Logger umLog = Logger.getLogger("UpgradeMaterials");
	    umLog.setParent(FMLLog.getLogger());
		//Begin Configuration File Stuff
		Configuration config = new Configuration(event.getSuggestedConfigurationFile());
		config.load();
		int UpgradeAmuletID = config.getItem("UpgradeAmulet", 4067).getInt();
		boolean useExpensiveAmuletRecipe = config.get(Configuration.CATEGORY_GENERAL, "useExpensiveAmuletRecipe", false).getBoolean(false);
	    umLog.info("Upgrade Amulet configuration item id: " + UpgradeAmuletID);
    	config.save();
		//End Configuration File Stuff
	}

	@Init
	public void init(FMLInitializationEvent event) {
		Item UpgradeAmulet = new UpgradeAmulet(UpgradeAmuletID);
		proxy.registerRenderers();
		//Register Upgrade Amulet for Language TODO: Add multiple languages to UpgradeAmulet
		LanguageRegistry.addName(UpgradeAmulet, "Upgrade Amulet");
		//I'm Lazy!
		ItemStack diamondStack = new ItemStack(Block.blockDiamond);
		ItemStack redstoneStack = new ItemStack(Item.redstone);
		ItemStack iron = new ItemStack(Item.ingotIron);
		ItemStack diamond = new ItemStack(Item.diamond);
		ItemStack gold = new ItemStack(Item.ingotGold);
		//Add Main Recipes TODO: Make UpgradeAmulet recipe ShapedRecipe
		if (useExpensiveAmuletRecipe == true) {
			GameRegistry.addShapelessRecipe(new ItemStack(UpgradeAmulet, 1), diamondStack, redstoneStack, redstoneStack, redstoneStack,redstoneStack, redstoneStack, redstoneStack, redstoneStack, redstoneStack);
		} else {
			GameRegistry.addShapelessRecipe(new ItemStack(UpgradeAmulet, 1), iron, redstoneStack, redstoneStack, redstoneStack,redstoneStack, redstoneStack, redstoneStack, redstoneStack, redstoneStack);
		}
		GameRegistry.addShapelessRecipe(new ItemStack(Item.ingotGold, 1), UpgradeAmulet, iron, iron, iron, iron, iron, iron, iron, iron);
		GameRegistry.addShapelessRecipe(new ItemStack(Item.diamond, 1), UpgradeAmulet, gold, gold, gold, gold);
	}
	@PostInit
	public static void postInit(FMLPostInitializationEvent event) {
		//Stub
	}
	public static int UpgradeAmuletID;
	public static int UpgradeAmulet;
	public static boolean useExpensiveAmuletRecipe;
}
